
        INCLUDE \masm32\include\masm32rt.inc

        .DATA

MultiplierLo dd 36B4A598h
MultiplierHi dd 89705F41h
Shift        dd 29

        .DATA?

DividendLo dd ?
DividendHi dd ?

QuotientLo dd ?
QuotientHi dd ?

Work1      dd ?
Work2      dd ?

Step       dd ?

        .CODE

_main   PROC

;     divisor = 1,000,000,000
;max dividend = 3B9A_CA03_4B82_FA17    (62 bits) 4294967310151776791
;max quotient = 5_4B82_FA17            (35 bits) 22741711383
;  multiplier = 8970_5F41_36B4_A597+1  2^93/1,000,000,000

test00: call    MTest
        mov     eax,MultiplierLo
        mov     edx,MultiplierHi
        sub     eax,1
        sbb     edx,0
        shr     edx,1
        rcr     eax,1
        add     eax,1
        adc     edx,0
        mov     MultiplierLo,eax
        mov     MultiplierHi,edx
        mov     eax,Shift
        dec     eax
        mov     Shift,eax
        inc     eax
        jnz     test00

        exit

_main   ENDP

;------------------------------------------------------------------------------

MTest   PROC

        xor     eax,eax
        mov     ecx,eax
        mov dword ptr Step,1

;    dividend = ecx:eax

MTest0: mov     DividendLo,eax
        mov     DividendHi,ecx

        mov     esi,eax
        mov     edx,MultiplierLo     ;partial multiplier lo
        mul     edx                  ;partial multiply to divide
        xor     ebx,ebx              ;zero for carry
        mov     edi,edx              ;save partial result
; shl     eax,1                                                       ;these lines don't seem to help except when
; adc     edi,ebx                                                     ;the un-incremented multiplier is used
        mov     eax,MultiplierHi     ;partial multiplier hi
        push    ebx                  ;save a zero for later
        mov     ebp,ebx              ;and in ebp
        mul     esi                  ;partial multiply to divide
        add     edi,eax              ;partial sum
        mov     eax,MultiplierLo     ;partial multiplier lo
        adc     ebx,edx              ;partial sum
        adc     ebp,ebp              ;partial sum
        mul     ecx                  ;partial multiply to divide
        add     eax,edi              ;partial sum
        pop     edi                  ;recall zero in edi
        adc     ebx,edx              ;partial sum
        adc     edi,ebp              ;partial sum
        mov     eax,MultiplierHi     ;partial multiplier hi
        mul     ecx                  ;partial multiply to divide
        add     eax,ebx              ;complete the sum
        adc     edi,edx              ;complete the sum
        mov     ecx,Shift
        shrd    eax,edi,cl           ;adjust the low quotient (carry)
        shr     edi,cl               ;adjust the high quotient (carry)

        mov     QuotientLo,eax
        mov     QuotientHi,edi

        mov     edi,1000000000
        xor     edx,edx
        mov     eax,DividendHi
        div     edi
        mov     Work2,eax
        mov     eax,DividendLo
        div     edi
        mov     Work1,eax

        cmp     eax,QuotientLo
        jnz     report_fail

        mov     eax,Work2
        cmp     eax,QuotientHi
        jnz     report_fail

        mov     eax,DividendLo
        mov     ecx,DividendHi

        cmp     ecx,3B9ACA03h
        jz      test_set_1

        cmp     ecx,0FFFFFFFFh
        jz      test_set_2

next_step:
        sub     edi,Step
        mov     Step,edi
        add     eax,edi
        adc     ecx,0
        jmp     MTest0

report_fail:
        print   chr$('Multiplier: ')
        mov     eax,MultiplierHi
        print   uhex$(eax),'_'
        mov     eax,MultiplierLo
        print   uhex$(eax),32,32
        print   chr$('Shift: ')
        mov     eax,Shift
        print   str$(eax),32,32
        print   chr$('Fail: ')
        mov     eax,DividendHi
        print   uhex$(eax),'_'
        mov     eax,DividendLo
        print   uhex$(eax),13,10
        ret

;added a special test point to the sequence (3B9A_CA03_4B82_FA17):

;3B9A_CA03_4277_0C00                           4294967310000000000
;max dividend = 3B9A_CA03_4B82_FA17  (62 bits) 4294967310151776791
;3B9A_CA03_7E11_D5FF                           4294967310999999999

test_set_1:
        cmp     eax,42770C00h
        jz      test_set_1a

        cmp     eax,4B82FA17h
        jnz     next_step

        mov     eax,7E11D5FFh
        jmp     MTest0

test_set_1a:
        sub     edi,Step
        mov     Step,edi
        mov     eax,4B82FA17h
        jmp     MTest0

;added 2 special points to the test sequence (FFFF_FFFF_FFFF_FFFE and FFFF_FFFF_FFFF_FFFF):

;FFFFFFFF_D5B51A00
;test FFFF_FFFF_FFFF_FFFE
;test FFFF_FFFF_FFFF_FFFF

test_set_2:
        cmp     eax,0D5B51A00h
        jz      test_set_2a

        cmp     eax,0FFFFFFFEh
        jz      test_set_2b

        cmp     eax,0FFFFFFFFh
        jnz     next_step

report_pass:
        print   chr$('Multiplier: ')
        mov     eax,MultiplierHi
        print   uhex$(eax),'_'
        mov     eax,MultiplierLo
        print   uhex$(eax),32,32
        print   chr$('Shift: ')
        mov     eax,Shift
        print   str$(eax),32,32
        print   chr$('Pass: ')
        mov     eax,0FFFFFFFFh
        print   uhex$(eax),'_'
        mov     eax,0FFFFFFFFh
        print   uhex$(eax),13,10
        ret

test_set_2a:
        mov     eax,0FFFFFFFEh
        jmp     MTest0

test_set_2b:
        mov     eax,0FFFFFFFFh
        jmp     MTest0

MTest   ENDP

;------------------------------------------------------------------------------

        END     _main

